VARS    EQU #5E80

        ORG #9900
        LD A,15
        CALL #8000
        LD DE,HP1TXT1+10
        LD B,4
HELP1   PUSH BC,HL,HL,DE
        LD DE,HOTXT3
        LD B,8
        CALL #80FF
        POP DE
        JR NZ,HELP2
        POP BC
        LD HL,HOTXT2
        LD BC,HOTXT3-HOTXT2
        LDIR
        JR HELP3
HELP2   LD HL,HOTXT1
        LD BC,HOTXT2-HOTXT1
        LDIR
        POP HL
        LD C,8
        LDIR
HELP3   LD HL,10
        ADD HL,DE
        EX DE,HL
        POP HL
        LD BC,8
        ADD HL,BC
        POP BC
        DJNZ HELP1
        LD HL,#FF00
        LD (VARS),HL
HELP4   CALL PRPAGE,CURS
HELP5   CALL #8081,#8087
        LD DE,KHELP1
        CALL JPKEY
        JR HELP5
H_LF    LD A,(IX)
        SUB 16
H_LF1   JR C,H_MIN
H_LF2   CALL CURS
        LD (IX),A
        JR HELP4
H_RT    LD A,(IX)
        ADD A,16
H_RT1   CP 24
        JR NC,H_MAX,H_LF2
H_UP    LD A,(IX)
        SUB 1
        JR H_LF1
H_DN    LD A,(IX)
        INC A
        JR H_RT1
H_MIN   XOR A
        JR H_MAX1
H_MAX   LD A,23
H_MAX1  CALL CURS
        LD (IX),A
        JR HELP4
H_EX    LD HL,HELP5
        PUSH HL
        LD HL,HOTKEY
        LD A,(IX)
        CALL #172D
        LD A,C

JPKEY   AND A
        JP M,#808A
        CP 14
        JP Z,#8104
        PUSH AF
        LD A,13
        CALL #8000
        POP AF
        LD E,(HL)
        INC HL
        LD D,(HL)
        LD HL,DE
JPKEY1  EXA
        LD A,(HL)
        AND A
        RET Z
        DEC A
        JR Z,JPKEY2
        EXA
        CP (HL)
        INC HL,HL,HL
        JR NZ,JPKEY1
JPKEY2  PUSH DE,AF
        CALL #8099,#811D,#8120
        POP AF,HL
        LD (IY-50),A
        JP #808A

CURS    EXA
        LD A,(IX)
        AND #0F
        ADD A,4
        LD D,A
        LD E,0
        CALL #80CF
        LD B,32
CURS1   LD A,(HL)
        XOR #50
        LD (HL),A
        INC HL
        DJNZ CURS1
        EXA
        RET

PRPAGE  LD A,(IX)
        LD C,A
        AND #F0
        LD B,A
        LD A,(IX+1)
        AND #F0
        CP B
        RET Z
        LD (IX+1),C
        LD HL,#80EA
        PUSH HL,BC
        CALL #809F
        LD A,(IX)
        AND #10
        OR 3
.4      RRCA
        INC A
        LD (HP0TXT+11),A
        LD HL,HP0TXT
        CALL #80E4
        POP AF
        LD HL,HP1TXT
        AND A
        RET Z
        LD HL,HP2TXT
        RET

KHELP1  DW H_LF,H_RT,H_UP,H_DN,H_LF
        DW H_RT,H_EX,HELP5
HOTKEY  DB "+-5892",7,"6734e!@#$"
        DB "no^",34,"SLh",14
        DB 1,1,1,1,1,1,1,1

HP0TXT  DB "Help page [ /2]",29
HP1TXT  DB 30,4,0,"SS/K - mark files "
        DB "by mask"
        DB 30,5,0,"SS/J - unmark all "
        DB "files"
        DB 30,6,0,"C, 5 - copy files"
        DB 30,7,0,"D, 8 - delete files"
        DB 30,8,0,"M, 9 - move files"
        DB 30,9,0,"Z, 2 - squeeze disk"
        DB 30,10,0,"CS/1 - change drive"
        DB 30,11,0,"R, 6 - catalogue "
        DB "editor"
        DB 30,12,0,"Y, 7 - system "
        DB "sector editor"
        DB 30,13,0,"3    - view text"
        DB 30,14,0,"4    - disk doctor"
        DB 30,15,0,"E    - view "
        DB "execute files"
HP1TXT1 DB 30,16,0,"SS/1 -             "
        DB 30,17,0,"SS/2 -             "
        DB 30,18,0,"SS/3 -             "
        DB 30,19,0,"SS/4 -             "
        DB 29
HP2TXT  DB 30,4,0,"N    - change "
        DB "ramdisk size"
        DB 30,5,0,"O    - hot overlay "
        DB "line editor"
        DB 30,6,0,"SS/H - hex/dec view"
        DB 30,7,0,"SS/P - view packed "
        DB "screen"
        DB 30,8,0,"CS/S - save "
        DB "catalogue to 160 track"
        DB 30,9,0,"CS/L - load "
        DB "catalogue from 160 track"
        DB 30,10,0,"H    - this help"
        DB 30,11,0,"Ext  - exit from "
        DB "help"
        DB 29
HOTXT1  DB "run "
HOTXT2  DB "nothing     "
HOTXT3  DB "        "