        ORG #5B00,#8000
        CALL WAITKEY
        LD A,(IX-91)
        PUSH AF
        LD A,4
        CALL #8102
        LD HL,#4000
        LD DE,BUFFSCR
        LD BC,6912
        LD A,(IX-78)
        LD (IX-78),L
        PUSH HL,DE,BC,AF
        LDIR
        LD HL,#5800
        LD BC,#02FF
        LD (HL),7
        CALL #80A8,CRTABS
MAIN1   HALT
        CALL MOVE,IN_1F
        JR Z,MAIN1
        POP AF,BC,HL,DE
        LD (IX-78),A
        LDIR
        LD (IX-77),255
        CALL WAITKEY
        POP AF
        JP #8102

WAITKEY CALL IN_1F
        JR NZ,WAITKEY
        RET

IN_1F   XOR A
        IN (#FE)
        CPL
        AND #1F
        RET

MOVE    LD HL,#4000
        LD BC,#001F
        EXX
        LD HL,TABLE_X
        LD DE,TABLE_S
        LD B,192
MOVE1   LD A,(DE)
        ADD A,(HL)
        LD (HL),A
        EXX
        LD D,TABLE_B[/2
        ADD A,A
        LD E,A
        RL D
        LD A,(DE)
        OR L
        LD L,A
        INC E
        LD A,(DE)
        LD (HL),A
        LD A,L
        AND C
        JP NZ,MOVE2
        LD A,L
        OR C
        LD L,A
        INC L
MOVE2   DEC L
        LD (HL),B
        LD A,L
        AND #E0
        LD L,A
        CALL INCY
        EXX
        INC HL,DE
        DJNZ MOVE1
        RET

INCY    INC H
        LD A,H
        AND 7
        RET NZ
        LD A,L
        ADD A,#20
        LD L,A
        RET C
        LD A,H
        SUB 8
        LD H,A
        RET

CRTABS  LD HL,TABLE_X
        LD DE,TABLE_S
        LD B,192
CR_T1   LD A,R
CR_T2   XOR #AA
        ADC A,B
        SUB C
        ADC A,D
        SUB E
        ADC A,H
        XOR L
        LD (CR_T2+1),A
        LD (HL),A
        LD C,A
        XOR B
        AND 7
        INC A
        LD (DE),A
        INC HL,DE
        DJNZ CR_T1
        LD HL,TABLE_B
CR_T3   PUSH BC
        LD A,B
        NEG
        LD C,A
        AND 7
        LD B,A
        LD A,#80
        JR Z,CR_T5
CR_T4   RRCA
        DJNZ CR_T4
CR_T5   EXA
        LD A,C
.3      RRA
        AND #1F
        LD (HL),A
        INC HL
        EXA
        LD (HL),A
        INC HL
        POP BC
        DJNZ CR_T3
        RET

TABLE_X EQU #E100
TABLE_B EQU #E200
TABLE_S EQU #E400
BUFFSCR EQU #E500